package com.glxp.udidl.admin.service.collect;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.github.pagehelper.PageHelper;
import com.glxp.udidl.admin.dao.collect.ThirdAliDrugMapper;
import com.glxp.udidl.admin.entity.collect.ThirdAliDrug;
import com.glxp.udidl.admin.req.collect.ThirdAliDrugAddRequest;
import com.glxp.udidl.admin.req.collect.ThirdAliDrugRequest;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import java.util.*;
import java.util.stream.Collectors;


@Service
@Slf4j
public class ThirdAliDrugService extends ServiceImpl<ThirdAliDrugMapper, ThirdAliDrug> {


    public List<ThirdAliDrug> filterList(ThirdAliDrugRequest thirdAliDrug) {
        if (thirdAliDrug == null) {
            return Collections.emptyList();
        }
        if (thirdAliDrug.getPage() != null) {
            int offset = (thirdAliDrug.getPage() - 1) * thirdAliDrug.getLimit();
            PageHelper.offsetPage(offset, thirdAliDrug.getLimit());
        }
        return this.baseMapper.filterList(thirdAliDrug);
    }


    public List<ThirdAliDrug> findByByApproved(String approvalNum) {
        return this.baseMapper.selectList(new LambdaQueryWrapper<ThirdAliDrug>().eq(ThirdAliDrug::getApprovalNum, approvalNum));
    }

    public void addThirdAliDrug(ThirdAliDrugAddRequest relCodeBatchRequest) {
        List<ThirdAliDrug> list = relCodeBatchRequest.getList();
        if (CollUtil.isNotEmpty(list)){
            List<String> nameCodes = list.stream().map(ThirdAliDrug::getNameCode).collect(Collectors.toList());
            List<String> updateNameCodes = new ArrayList<>();
            List<ThirdAliDrug> drugs = this.list(new LambdaQueryWrapper<ThirdAliDrug>().in(ThirdAliDrug::getNameCode, nameCodes));
            if (CollUtil.isNotEmpty(drugs)){
                updateNameCodes = drugs.stream().map(ThirdAliDrug::getNameCode).collect(Collectors.toList());
            }
            List<ThirdAliDrug> addList = new ArrayList<>();
            List<String> finalUpdateNameCodes = updateNameCodes;
            list.forEach(item -> {
                if (finalUpdateNameCodes.size() > 0 ){
                    if (!finalUpdateNameCodes.contains(item.getNameCode())){
                        item.setId(null);
                        addList.add(item);
                    }
                }else {
                    item.setId(null);
                    addList.add(item);
                }
            });

            if (CollUtil.isNotEmpty(addList)){
                this.baseMapper.saveOrUpdateBatch(addList);
            }

        }
    }
}
